Given a binary tree with n nodes, your task is to check if it's possible to partition the tree to two trees which have the equal sum of values after removing exactly one edge on the original tree.

Example 1:

Input:
5
/ \
10 10
/ \
2 3 Output: True
Explanation:
5
/
10 Sum: 15 10
/ \
2 3 Sum: 15

Example 2:

Input:
1
/ \
2 10
/ \
2 20 Output: False
Explanation: You can't split the tree into two trees with equal sum after removing exactly one edge on the tree.

Note:

  1. The range of tree node value is in the range of [-100000, 100000].
  2. 1 <= n <= 10000

这道题让我们划分等价树,就是说当移除一条边后,被分成的两棵树的结点之和需要相等。通过观察题目中的例子可以发现,如果将每个结点的结点值变成其所有子结点的结点值之和再加上当前的结点值,那么对于例子1来说,根结点的结点值就变成了 30,断开位置的结点就变成了 15,可以发现其实只要断开位置的结点值是根结点值的一半,就存在等价划分。所以这道题的难点就是更新每个结点的结点值,可以使用递归来做。博主最开始使用的是 unordered_set,把更新后的每个结点值都存入集合中,但是对于 test case: [0, 1, -1] 会 fail, 仔细分析下这个 case,发现更新后的根结点值还是0,而且0已经被存入集合了,而0除以2还是0,在集合中存在,会返回 true,但其实这棵树是不能等价划分的。0的情况确实比较特殊,所以这里要使用 HashMap,建立更新后的结点值和其出现次数之间的映射,这样只有 HashMap 中0的个数大于1的时候,才返回 true。这样完美的避开了根结点为0的陷阱,Perfect!参见代码如下:

解法一:

class Solution {
public:
bool checkEqualTree(TreeNode* root) {
unordered_map<int, int> m;
int sum = helper(root, m);
if (sum == ) return m[] > ;
return (sum % == ) && m.count(sum / );
}
int helper(TreeNode* node, unordered_map<int, int>& m) {
if (!node) return ;
int cur = node->val + helper(node->left, m) + helper(node->right, m);
++m[cur];
return cur;
}
};

我们也可以使用 stack 来做,将所有的结点和存入到栈中,然后依次出栈,看是否有结点和正好等于 sum/2,这里还是要注意当 sum=0 的情况同时根结点值又正好是0的情况,最简单的处理办法就是将栈顶元素提前移除,这样就不会有 sum=sum/2 这种情况发生了,参见代码如下:

解法二:

class Solution {
public:
bool checkEqualTree(TreeNode* root) {
stack<int> st;
int sum = helper(root, st);
st.pop();
if (sum % != ) return false;
while (!st.empty()) {
if (st.top() == sum / ) return true;
st.pop();
}
return false;
}
int helper(TreeNode* node, stack<int>& st) {
if (!node) return ;
st.push(helper(node->left, st) + helper(node->right, st) + node->val);
return st.top();
}
};

Github 同步地址:

https://github.com/grandyang/leetcode/issues/663

参考资料:

https://leetcode.com/problems/equal-tree-partition/

https://leetcode.com/problems/equal-tree-partition/discuss/149437/Logical-Thinking-with-Java-Code-Beats-97.25

https://leetcode.com/problems/equal-tree-partition/discuss/106727/JavaC%2B%2B-Simple-solution-with-only-one-HashMaplessgreater.

LeetCode All in One 题目讲解汇总(持续更新中...)

最新文章

  1. WebApp中的页面生命周期及路由管理
  2. 如何在iOS9的plist文件中配置不使用https
  3. IIS 发布网站 ashx无法访问
  4. UDP 打洞 原理解释
  5. Map,List,POJO深拷贝(序列化实现)方法与注意事项
  6. 高并发下,log4j日志打印行数导致的内存溢出问题
  7. [ZJOI2010]基站选址
  8. 三、数据API-3
  9. react将字符串转义成html语句
  10. 【js】event(事件对象)详解
  11. 如何修改Oracle服务IP地址
  12. 照片 GPS 信息查询
  13. Xor-MST CodeForces - 888G (最小生成树,分治)
  14. SSD 相关基础知识
  15. testng执行用例失败,再次执行
  16. [NOIp2003提高组]神经网络
  17. C#判断一个字符串是否全部为空格的一个简单方法
  18. Ceph 时钟偏移问题 clock skew detected 解决方案--- 部署内网NTP服务
  19. 2.2、js基础---预解析和严格模式
  20. 微信小程序-ios系统-下拉上拉出现白色,如何处理呢?

热门文章

  1. kvm之十二:虚拟机迁移
  2. 爬虫(requests)
  3. (转)SQLite内置函数
  4. 设计模式之 外观模式详解(Service第三者插足,让action与dao分手)
  5. 多目标跟踪(MOT)论文随笔-POI: Multiple Object Tracking with High Performance Detection and Appearance Feature
  6. C语言第四次作业--嵌套循环
  7. Beta冲刺第五天
  8. 201621123050 《Java程序设计》第2周学习总结
  9. Tornado 网站demo 三
  10. tornado web高级开发项目